﻿using System.Windows.Forms;
using HeuristicLab.Core.Views;
using HeuristicLab.MainForm;

using TGraph = HeuristicLab.EvolutionTracking.GenealogyGraph
                <
                  HeuristicLab.EvolutionTracking.GenealogyGraphNode<HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.ISymbolicExpressionTree>,
                  HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.ISymbolicExpressionTree
                >;

namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
  [View("SymbolicDataAnalysisGenealogyView")]
  [Content(typeof(TGraph), IsDefaultView = false)]
  public sealed partial class SymbolicDataAnalysisGenealogyView : ItemView {
    public new TGraph Content {
      get { return (TGraph)base.Content; }
      set { base.Content = value; }
    }

    public SymbolicDataAnalysisGenealogyView() {
      InitializeComponent();
    }

    protected override void DeregisterContentEvents() {
      // TODO: Deregister your event handlers here
      base.DeregisterContentEvents();
    }

    protected override void RegisterContentEvents() {
      base.RegisterContentEvents();
      // TODO: Register your event handlers here
    }

    #region Event Handlers (Content)
    // TODO: Put event handlers of the content here
    #endregion

    protected override void OnContentChanged() {
      base.OnContentChanged();
      if (Content == null) {
        // TODO: Add code when content has been changed and is null
      } else {
        genealogyGraphChart1.GenealogyGraph = Content;
        // TODO: Add code when content has been changed and is not null
      }
    }


    protected override void SetEnabledStateOfControls() {
      base.SetEnabledStateOfControls();
      // TODO: Enable or disable controls based on whether the content is null or the view is set readonly
    }

    #region Event Handlers (child controls)
    // TODO: Put event handlers of child controls here.
    #endregion
  }
}
